#include <stdlib.h>
#include <stdio.h>

FILE *input_file;
FILE *output_file;

unsigned char header[6];
unsigned int dimensione_blocco_compresso;
unsigned int dimensione_blocco_decompresso;
int counter;
int contatore_sconosciuto=0;
char filename[256];
char filename2[256];
unsigned char *buffer;
char command[256];


void decode(char *file)
{
	counter=0;

	// aprile file .bin
	input_file=fopen(file,"rb");
	if (!input_file)
		return;

	while (!feof(input_file))
	{
		// legge i 6 bytes di header
		memset(header,6,0);
		fread(header,6,1,input_file);
		// i primi due bytes sono i byte da
		// leggere che compongono il blocco GZIP
		dimensione_blocco_compresso=0;
		dimensione_blocco_compresso=header[1]<<8;
		dimensione_blocco_compresso+=header[0];
		// i successivi due bytes sono la dimensione
		// del blocco decompresso.
		// Per la ricostruzione del file .bin questi due bytes 
		// sono presi dalla fine del file .gz
		// (ultimi 4 bytes: vanno presi i primi due bytes)
		// (vedi funzione encode())
		dimensione_blocco_decompresso=0;
		dimensione_blocco_decompresso=header[3]<<8;
		dimensione_blocco_decompresso+=header[2];

		// contatore di utilizzo sconosciuto.
		// Per quanto riguarda kernel.bin si ferma a 9
		// e guarda caso e' a partire da 9 che si incomincia
		// ad intravedere del testo
		contatore_sconosciuto=0;
		contatore_sconosciuto=header[5]<<8;
		contatore_sconosciuto+=header[4];

		if (dimensione_blocco_compresso==0)
			break;

		memset(filename,0,256);
		sprintf(filename,"%s%d.gz",file,counter);
		printf("\nCreating file %s%d!",file,counter);

		buffer=(unsigned char*)malloc(dimensione_blocco_compresso);
		// legge il blocco GZIP dal file .bin
		// ogni blocco incomincia con la stringa esadecimale
		// 1F8B08
		if (fread(buffer,dimensione_blocco_compresso,1,input_file)!=-1)
		{	
			// crea il file GZIP
			output_file=fopen(filename,"wb");
			fwrite(buffer,dimensione_blocco_compresso,1,output_file);
			fclose(output_file);
			memset(command,0,256);
			// decomprime il file .gz usando il comando esterno gunzip
			sprintf(command,"gunzip -f %s",filename);
			system(command);
//			printf("\nFile %s created!",filename);
			// cancella il file .gz (ormai non server)
			unlink(filename);
		}
		else
			break;
		free(buffer);
		counter++;
	}
	fclose(input_file);
}

void encode(char *file)
{
	counter=0;

	// crea file .bin
	output_file=fopen(file,"wb");

	memset(filename,0,256);
	sprintf(filename,"%s%d",file,counter);

	// apre i files .bin0, bin1, bin2, etc etc
	while (input_file=fopen(filename,"rb"))
	{
		// comprimi i file con gzip con parametri:
		// -9 per massima compressione
		// -n per non includere extra info (filename e altro)
		// in questo modo non abbiamo differenze 
		// otteniamo i files .bin0.gz, .bin1.gz, .bin2.gz, ecc ecc 
		memset(command,0,256);
		sprintf(command,"gzip -9 -n %s",filename);
		system(command);
		fclose(input_file);
		// cancella i files .bin0, .bin1, .bin2 etc etc (non servono piu')
		unlink(filename);
		memset(filename2,0,256);
		sprintf(filename2,"%s.gz",filename);
		// apri i files .bin0.gz, .bin1.gz, .bin2.gz, etc etc
		input_file=fopen(filename2,"rb");
		if (!input_file)
			break;
		// calcola la dimesione del blocco gzip (=dimensione file .gz)
		fseek(input_file,0L,SEEK_END);
		dimensione_blocco_compresso=ftell(input_file);
		fseek(input_file,0L,SEEK_SET);
		// leggi tutto il file .gz
		buffer=(unsigned char*)malloc(dimensione_blocco_compresso);
		fread(buffer,dimensione_blocco_compresso,1,input_file);
		// crea l'header per il file .bin
		memset(header,0,6);
		// primi due bytes sono la dimensione del file .gz
		header[0]=dimensione_blocco_compresso&0xFF;
		header[1]=dimensione_blocco_compresso>>8;
		// dimensione dei dati decompressi: la prendiamo
		// dai ultimi 4 bytes del blocco gz (primi due bytes)
		header[2]=buffer[dimensione_blocco_compresso-4];
		header[3]=buffer[dimensione_blocco_compresso-3];
		// contatore sconosciuto: per kernel.bin parte da 0 e si ferma a 9
		header[4]=counter<9?counter:9;
		header[5]=00;
		// scrive l'header su file .bin
		fwrite(header,6,1,output_file);
		// scrive il blocco .gz su file .bin
		fwrite(buffer,dimensione_blocco_compresso,1,output_file);
		counter++;
		// chiudi e cancella il file .gz 
		fclose(input_file);
		unlink(filename2);
		memset(filename,0,256);
		sprintf(filename,"%s%d",file,counter);
	}
	// il file .bin ha due bytes a 0 finali (per indicare la fine del file penso)
	memset(header,0,6);
	fwrite(header,2,1,output_file);

	printf("\nFile %s created!\n",file);
	fclose(output_file);
}

// in realta' alcuni file .bin sono file .gz puri
// e basta rinominarli in .gz e scompattarli
// direttamente con Winzip senza usare questo programma
// ad esempio il file title.bin e' un immagine RAW
// di dimensione 320x224 con header di 12 bytes

void main(int argc,char *argv[])
{

	if (argc<3)
	{
		printf("\nFF7 .BIN files decoder by +=|KaRMa|=+\n\n");
		printf("Syntax: ff7dec d file.bin\n\n");
		printf("        decodes file.bin in file.bin0, file.bin1, file.bin2, etc etc\n\n");
		printf("        ff7dec e file.bin\n\n");
		printf("        encodes file.bin0, file.bin1, file.bin2, etc etc in file.bin\n\n");
		exit(0);
	}

	if (!strcmp(argv[1],"d"))
		decode(argv[2]);
	else
	if (!strcmp(argv[1],"e"))
		encode(argv[2]);

}
